#include <stdio.h>
#include <windows.h>
#include <unistd.h>

char serviceName[] = "iTunnelService";
char iTunnelPath[] = "\"iTunnel.exe\" 22";

// Variables d'état du service
SERVICE_STATUS iTunnelStatus;
SERVICE_STATUS_HANDLE iTunnelHandle;

// Variables d'état du processus iTunnel
PROCESS_INFORMATION processInformation;

void ControlHandler(DWORD request) {
    switch(request) {
        case SERVICE_CONTROL_STOP:
        case SERVICE_CONTROL_SHUTDOWN:
            // On arrête le processus iTunnel
            TerminateProcess(processInformation.hProcess, 0);
    }
}

void ServiceMain(int argc, char** argv) {
    STARTUPINFO startupInfo;

    iTunnelStatus.dwServiceType = SERVICE_WIN32;
    iTunnelStatus.dwCurrentState = SERVICE_START_PENDING;
    iTunnelStatus.dwControlsAccepted = SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_SHUTDOWN;
    iTunnelStatus.dwWin32ExitCode = 0;
    iTunnelStatus.dwServiceSpecificExitCode = 0;
    iTunnelStatus.dwCheckPoint = 0;
    iTunnelStatus.dwWaitHint = 0;

    iTunnelHandle = RegisterServiceCtrlHandler("iTunnelService", (LPHANDLER_FUNCTION) ControlHandler);
    if (iTunnelHandle == 0) {
        return;
    }

    ZeroMemory(&processInformation, sizeof(processInformation));
    ZeroMemory(&startupInfo, sizeof(startupInfo));
    startupInfo.cb = sizeof(startupInfo);

    // Lancement de iTunnel
    if (!CreateProcess(NULL, iTunnelPath, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL, &startupInfo, &processInformation)) {
        return;
    }

    // Service démarré correctement, on notifie le gestionnaire de service
    iTunnelStatus.dwCurrentState = SERVICE_RUNNING;
    SetServiceStatus(iTunnelHandle, &iTunnelStatus);

    // On attent que le processur iTunne se termine
    WaitForSingleObject(processInformation.hProcess, INFINITE);
    CloseHandle(processInformation.hProcess);
    CloseHandle(processInformation.hThread);

    // iTunnel s'est arrêté, on notifie le gestionnaire de service
    iTunnelStatus.dwCurrentState = SERVICE_STOPPED;
    SetServiceStatus(iTunnelHandle, &iTunnelStatus);
    return;
}

int main() {
    SERVICE_TABLE_ENTRY ServiceTable[2];
    ServiceTable[0].lpServiceName = serviceName;
    ServiceTable[0].lpServiceProc = (LPSERVICE_MAIN_FUNCTION) ServiceMain;
    ServiceTable[1].lpServiceName = NULL;
    ServiceTable[1].lpServiceProc = NULL;
    StartServiceCtrlDispatcher(ServiceTable);
}
